package com.sxtvs.api.chatgpt.controller;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.sxtvs.api.chatgpt.dto.CompletionsParamsDto;
import com.sxtvs.api.chatgpt.dto.CompletionsRequestDto;
import com.sxtvs.api.chatgpt.dto.CompletionsResponseDto;
import com.sxtvs.api.chatgpt.dto.GptResponse;
import com.sxtvs.core.sls.AliyunLogger;
import lombok.SneakyThrows;
import org.apache.hc.client5.http.classic.HttpClient;
import org.apache.hc.client5.http.fluent.Request;
import org.apache.hc.client5.http.impl.classic.HttpClientBuilder;
import org.apache.hc.core5.http.ContentType;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.nio.charset.StandardCharsets;

@RestController
public class ChatGptController {

    @Autowired
    private ObjectMapper objectMapper;

    @Autowired
    private AliyunLogger logger;

    @SneakyThrows
    @RequestMapping("completions")
    public CompletionsResponseDto completions(@RequestBody CompletionsRequestDto dto) {
        var paramsDto = new CompletionsParamsDto(dto.getPrompt());
        var params = objectMapper.writeValueAsString(paramsDto);
        logger.info("prompt", dto.getPrompt(), "request", params);
        var response = Request.post("https://api.openai.com/v1/completions")
                .setHeader("Authorization", "Bearer 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")
                .bodyString(params, ContentType.APPLICATION_JSON)
                .execute()
                .returnContent()
                .asString(StandardCharsets.UTF_8);
        var gptResponse = objectMapper.readValue(response, GptResponse.class);
        var completionsResponseDto = new CompletionsResponseDto();
        var text = gptResponse.getChoices().stream().map(GptResponse.ChoicesDTO::getText).findFirst().orElse("").trim();
        completionsResponseDto.setResult(text);
        logger.info("prompt", dto.getPrompt(), "result", text, "response", response);
        return completionsResponseDto;
    }

}
